# :Author: SAKIMA Kimihisa
# :Contact: sakima@hooktail.org
# :Date: $Date: 2005-10-13 02:00:51 $
#--
$KCODE = "EUC" 
require 'digest/md5'


# ==========================================================
# 饤$...$ִ᥽å
# ==========================================================
def inline_math(buf)

  re_inlinemath = /\$(.*?)\$/      # 饤Υѥ
  re_reference = /(\\ref\{.*?\})/  # \ref{*} Υѥ
  re_toalign = /\\\\/              # alignĶذܹԤѥ
  re_tag = /\\tag\{(.*?)\}/        # \tag{*} Υѥ
  
  inlineEquations = Array.new  # Ǽ
  
  # ˳Ǽ
  inlineEquations << buf.scan(re_inlinemath)
  inlineEquations << buf.scan(re_reference)
  
  #  |md5| ִ
  buf.gsub!(re_inlinemath) { "|" + Digest::MD5.hexdigest($1) + "|" }
  
  # \ref{*}  |md5| ִ
  buf.gsub!(re_reference) { "|" + Digest::MD5.hexdigest($1) + "|" }
  
  # ͥȤ줿եåȤˤʣǤ
  inlineEquations.flatten!.uniq!
  
  # бreStructuredTextǸ˽
  # ʥ饤ο֤
  n = inlineEquations.length
  i = 0
  while i < n
    # ļФ
    inEquation = inlineEquations.pop
    if (inEquation =~ re_tag) then
      # \tag{*}  $...$ ĶǻȤʤΤǿˤ
      buf << "\n.. |" + Digest::MD5.hexdigest(inEquation) + "| raw:: latex\n\n"
      buf << "  $" + inEquation.gsub(re_tag) { "(" + $1 + ")" } + "$\n\n\n"     
    elsif (inEquation =~ re_toalign) then
      #  \\ ޤΤ align Ķˤ
      # 顼ˤʤ礬Τ & ϼ 
      buf << "\n.. |" + Digest::MD5.hexdigest(inEquation) + "| raw:: latex\n\n"
      buf << "  \\begin{align*}" + inEquation.gsub(/&/,"") + "\\end{align*}\n\n\n"
    else
      # ¾ϤΤޤ
      buf << "\n.. |" + Digest::MD5.hexdigest("#{inEquation}") + "| raw:: latex\n\n"
      buf << "  $#{inEquation}$\n\n\n"
    end
    i += 1
  end
  
  return buf
  
end


# ==========================================================
# ǥץ쥤<tex>...</tex>ִ᥽å
# ==========================================================
def display_math(buf)
  
  # tex   align* Ķ
  re_tex = /<tex>(.*?)<\/tex>/m
  
  # ǥȤƶԤ
  buf.gsub!(re_tex){
    "\n.. raw:: latex\n\n  \\begin{align*}\n" +
    $1.gsub(/^/m, "    ").gsub(/^\s*\n/m, "") +
    "  \\end{align*}\n\n"
  }
  
  return buf
  
end


# ==========================================================
# եŬڤѴ
# ==========================================================
def figure(buf)
  
  # image ⤷ figure ǥ쥯ƥ֤Υѥ
  re_conv_eps = /\.\.\s+(figure|image)\s*::\s+(.*)\.(png|gif)/
  re_make_bb = /\.\.\s+(figure|image)\s*::\s+(.*)\.(jpg|pdf)/

  # Ǽ
  images = Array.new

  # ե̾
  images << buf.scan(re_conv_eps)
  images << buf.scan(re_make_bb)
  # png, gifξϥǥ쥯ƥγĥҤepsˤ
  buf.gsub!(re_conv_eps) { ".. " + $1 + ":: " + $2 + ".eps" }
  
  # ե̾ǼƤեåȤˤ
  images.flatten!
  
  # eps⤷bbե
  # ʻȤƤեο֤
  n = images.length
  i = 0
  while i < n
    fBody = images[i+1]  # ĥҤե̾
    fTail = images[i+2]  # ĥ̾
    
    orgFile = fBody + "." + fTail  # βե̾
    pngFile = fBody + ".png" # epsե̾
    epsFile = fBody + ".eps" # epsե̾
    
    # եμˤŬ
    if (fTail == "png") then
      `convert -compress zip #{orgFile} eps2:#{epsFile}`  # png
    elsif (fTail == "gif") then
      `convert -compress lzw #{orgFile} eps3:#{epsFile}`  # gif
    elsif (fTail == "jpg" || fTail == "pdf") then
      `ebb #{orgFile}`  # jpgepsˤbbBoundingBox˥եĤ
    end
    
    # 3ĤǲեʬʤΤǡ+3פȼβ
    i += 3
  end
  
  return buf
  
end


# ==========================================================
# @@̿ν
# ==========================================================
def atat(buf)
  
  # @@̿γƼѥ
  re_author = /@@author:\s*(.*?)\s*@@/
  re_date = /@@accept:\s*(.*?)\s*@@/
  re_reference = /@@reference:\s*(.*?)\s*@@/
  re_category = /@@category:\s*(.*?)\s*@@/
  re_information = /@@information:\s*(.*?)\s*@@/

  # ѥ˥ޥåʬ
  author = buf.scan(re_author).join
  date = buf.scan(re_date).join

  # @@author:...@@ס@@accept:...@@פ
  #  줾쥿ȥľΡ:Author: ...,:Date: ...פѴ
  if buf =~ re_author
    buf.sub!(/\n(.*)(====|----|````|::::|\"\"\"\"|~~~~|\^\^\^\^|____|\*\*\*\*|\+\+\+\+|####|<<<<|>>>>)\n/) { "\n" + $1 + $2 +  "\n:Author: " + author + "\n" + ":Date: " + date + "\n\n" }
  end 

  # @@̿᤽ΤΤϼ
  buf.gsub!(re_author, "")
  buf.gsub!(re_date, "")
  buf.gsub!(re_reference, "")
  buf.gsub!(re_category, "")
  buf.gsub!(re_information, "")
  
  return buf
  
end


# ==========================================================
# ¾
# ==========================================================
def etc(buf)
  
  # footnoteϿˤ[*]  [#]
  buf.gsub!(/ \[\*\]\_ ?/, " \[#\]\_ ")
  buf.gsub!(/^\.\.\s+\[\*\]\s+/, "\.\. \[#\] ")

  # Ƭѥڡ
  buf.gsub!(/^/e, "")

  # ֡פ֡פˡ֡פ֡פִ
  buf.gsub!(//e, "")
  buf.gsub!(//e, "")

  return buf
  
end
