# :Author: SAKIMA Kimihisa
# :Contact: sakima@hooktail.org
# :Date: $Date: 2005-10-13 02:18:15 $
#--
$KCODE = "EUC"


# ==========================================================
# 饹ִ
# ==========================================================
def documentclass(buf)
  
  class_name = "jsarticle"
  class_opt = "11pt,a4paper"
  pkg_name = "hooktail" 
  
  # ɥȥ饹ִ
  buf.sub!(/^\\documentclass.*$/,
  "\\documentclass\[#{class_opt}\]\{#{class_name}\}\n\\usepackage\{#{pkg_name}\}")
  
  return buf
  
end


# ==========================================================
# ץꥢ֥
# ==========================================================
def preamble(buf)
  
  # color, graphicx ѥåФ dvipdfm ץɲ
  buf.sub!(/\\usepackage\{color\}/, "\\usepackage\[dvipdfm\]\{color\}")
  buf.sub!(/\\usepackage\{graphicx\}/, "\\usepackage\[dvipdfm\]\{graphicx\}")

  # Ⱥѥå̿
  buf.sub!(/\\usepackage\[DIV12\]\{typearea\}\n/, "")
  buf.sub!(/\\usepackage\{ae\}\n/, "")
  buf.sub!(/\\usepackage\[.*\]\{inputenc\}\n/, "")
  buf.sub!(/\\usepackage\{babel\}\n/, "")
  buf.sub!(/\\usepackage\{aeguill\}\n/, "")

  # amssymb, bm ѥåɲ
  buf.sub!(/\\usepackage\{amsmath\}/, "\\usepackage\{amsmath,amssymb,bm\}")

  # hyperref ѥåΥץѹ
  buf.sub!(/\\usepackage\[(colorlinks=true,linkcolor=blue,urlcolor=blue)\]\{hyperref\}/){
    "\\usepackage\[dvipdfm,bookmarks=true,bookmarksnumbered=true,pdfstartview=\{FitH -32768\},pdfdisplaydoctitle=true," +
    $1 +
    "\]\{hyperref\}" +
    "\n\\ifnum 42146=\\euc\"A4A2 \\AtBeginDvi\{\\special\{pdf:tounicode EUC-UCS2\}\}\\else" +
    "\n\\AtBeginDvi\{\\special\{pdf:tounicode 90ms-RKSJ-UCS2\}\}\\fi"
  }
  
  return buf
  
end


# ==========================================================
# latexȥ
# ==========================================================
def titlehooktail(buf)
  
  # TeXեauthorִ
  buf.gsub!(/\\author\{(.*?)\}/){
    "\\author\{" + $1 + "ʪΤץ\}"
  }
  buf.gsub!(/pdfauthor=\{(.*?)\}/){
    "pdfauthor=\{" + $1 + "ʪΤץ\}"
  }
  
  return buf
  
end


# ==========================================================
# latexʸ
# ==========================================================
def latexbody(buf)
 
  # ̾ĤǤ
  buf.gsub!(/\\includegraphics/, "\\includegraphics\[scale=0\.55\]")
  buf.gsub!(/\\includegraphics(.*\}$)/){
    "\\begin\{center\}\\includegraphics" + $1 + "\\end\{center\}"
  }

  # \end{quote} \end{itemize} θβԤ
  buf.gsub!(/(\\end\{quote\}).*?\n/) { $1 }
  buf.gsub!(/(\\end\{itemize\}).*?\n/) { $1 }
  
  return buf
  
end
