#!/usr/bin/env ruby
#
# ==========================================================
# kagiPDF
# ==========================================================
# :Author: SAKIMA Kimihisa
# :Contact: sakima@hooktail.org
# :Date: $Date: 2005-10-13 23:14:52 $
#
# 
# ====
#
#   ̾⡼
#     kagipdf.rb [OPTION] infile
#
#   ե륿⡼
#     kagipdf.rb [OPTION] < stream
#     stream | kagipdf.rb [OPTION]
#
#
# ץ
# ==========
#
#   -o <string>
#       ȥץåpdfե̾ꡥ
#       ) kagipdf.rb -o index.pdf infile
#
#   -k <type>
#       LaTeXեʸɤ˥åȡǥեȤEUC-JP
#       <type> ˤ s, u, e Τ줫ꡥ
#       줾ʸɤShift JISUTF-8EUC-JP˥åȡ
#       ) kagipdf.rb -ks infile
#
#   --notex
#       platexѥ¹Ԥʤ
#       ) kagipdf.rb --notex infile
#
#   --nopdf
#       dvipdfmxˤpdfեԤʤ
#       ) kagipdf.rb --nopdf infile
#
#   --style <type>
#       LaTeX
#       <type> ˤ hooktail, report, Τ줫ꡥ
#       ) kagipdf.rb --style report infile
#
#--
require 'nkf'
require 'iconv'
require 'optparse'


# ==========================================================
# ץ
# ==========================================================
opt = OptionParser.new
opt.banner = "Usage: #{File.basename($0)} [-o] file"
# latexʸɻ
opt.on('-k VAL'){|v|
  $texchar = v
}
# ե̾
opt.on('-o VAL'){|v|
  $out_file_pdf_opt = v
}
# latexѥ򤷤ʤ
opt.on('--notex'){
  $notex = true
}
# pdfʤ
opt.on('--nopdf'){
  $nopdf = true
}
# 
$style = "hooktail"  # ǥե
opt.on('--style VAL'){|v|
  $style = v
}
opt.parse!(ARGV)


# ==========================================================
# 
# ==========================================================
begin
  if FileTest::symlink?(__FILE__) then
    org_path = File::dirname(File::readlink(__FILE__))
  else
    org_path = File::dirname(__FILE__)
  end
  $:.unshift(org_path.untaint)
  require 'extension'
  require 'fairlatex'
  if $stdin.tty?  # ɸϤüξ̾⡼ɡ
    in_file  = ARGV.shift
    contents = open(in_file){ |io| io.read }
  else  # ѥס쥯Ȥμ¹ԡʥե륿⡼ɡ
    in_file  = "kagipdf_default.txt"
    contents = $stdin.read
  end
  in_file       = $out_file_pdf_opt if $out_file_pdf_opt  # ե̾ꥪץ󤬤
  out_file      = File.basename(in_file, ".*")  # ĥҤ
  out_file_reST = out_file + ".reST"
  out_file_tex  = out_file + ".tex"
  out_file_pdf  = out_file + ".pdf"
rescue Exception
  # 顼
end
# ϥեʸɤEUC-JPȤʸCR
contents = NKF.nkf("-e -m0 -d", contents)



# ==========================================================
# ᥤ
# ==========================================================

# äݳĥν
contents = inline_math(contents)   # 饤
contents = display_math(contents)  # ǥץ쥤
contents = figure(contents)        # 
contents = atat(contents)          # @@̿
contents = etc(contents)           # ¾

# ̩reStructuredTextȤƥե
File.open(out_file_reST, "w"){ |file|
  file.write contents
}

###--- rst2latex.pyե ---###
pid1 = fork{
  # UTF-8ˤrst2latex.pyˤɬפ뤿ᡤlv򤫤ޤƤ
  exec("lv -Ou8 #{out_file_reST} > tmp$$; rst2latex.py -o utf-8 --use-latex-docinfo --use-latex-footnotes tmp$$ #{out_file_tex}; lv -Oej #{out_file_tex} > tmp$$; mv tmp$$ #{out_file_tex}")
}
exitpid, status = *Process.waitpid2(pid1)  # ҥץλޤԤ

# latex
texsource = open(out_file_tex){ |io| io.read }
texsource = documentclass(texsource)  # 饹
texsource = preamble(texsource)  # ץꥢ֥
texsource = titlehooktail(texsource) if $style == "hooktail" # ȥ
texsource = latexbody(texsource)  # ʸ

# latexʸɤλ
# ǥեȤeuc-jpcygwinξShift_JISˡץͥ补
if $texchar == "s"
  texsource = NKF.nkf("-s -m0 -c", texsource)
elsif $texchar == "e"
  texsource = NKF.nkf("-e -m0 -d", texsource)
elsif $texchar == "u"
  texsource = Iconv.iconv("UTF-8", "eucJP", texsource)
elsif RUBY_PLATFORM =~ /cygwin/
  texsource = NKF.nkf("-s -m0 -c", texsource)
end

# latexե
File.open(out_file_tex, "w"){ |file|
  file.write texsource
}

###--- platexե ---###
unless $notex
  2.times{  # ѥ2Ϣ³
    pid2 = fork{
      # 10Ķ⤷ϥե륵2048ХĶǽǤڤ
      # platexѥϥ顼ФƤǻߤʤ
      exec("ulimit -t 10 -f 2048; platex -interaction=nonstopmode #{out_file_tex}")
    }
    exitpid, status = *Process.waitpid2(pid2)  # ҥץλޤԤ
  }
end

###--- dvipdfmxե ---###
unless $nopdf || $notex
  pid3 = fork{
    exec("dvipdfmx #{out_file}")
  }
  exitpid, status = *Process.waitpid2(pid3)  # ҥץλޤԤ
end

# פʤե뤬оä
texext = [".aux", ".log", ".out", ".reST"]
texext.each {|ext|
  File.delete(out_file + ext) if FileTest.exist?(out_file + ext)
}
